<template>
  <GenericLayout>
    <template #header>
      <Header
        fastplatform-logo
        :title="pageTitle"
      />
    </template>
    <template #page-content>
      <div class="q-gutter-y-md">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
        </template>

        <template v-if="loading">
          <q-card>
            <q-card-section class="text-center">
              <q-spinner-dots
                size="md"
                color="primary"
              />
            </q-card-section>
          </q-card>
        </template>

        <template v-else-if="messages && holdings">
          <q-btn
            v-if="isDesktopPlatform && canCreateTicket"
            icon="las la-pen"
            :label="$gettext('New request')"
            color="primary"
            @click="onClickNewMessage"
            class="q-my-sm"
          />

          <q-card
            :square="!isDesktopPlatform"
            v-if="formattedMessages.length"
          >
            <q-infinite-scroll
              :offset="200"
              ref="messageListInfiniteScroll"
              @load="onLoadMoreMessages"
            >
              <q-list separator>
                <component
                  :is="whichListItemComponent(message)"
                  v-for="message in formattedMessages"
                  :key="message.key"
                  v-bind="message"
                  :holdings="holdings"
                  @click="onClickMessage(message)"
                />
              </q-list>
              <template #loading>
                <div class="row justify-center q-my-md">
                  <q-spinner-dots
                    color="primary"
                    size="40px"
                  />
                </div>
              </template>
            </q-infinite-scroll>
          </q-card>
          <q-card v-else>
            <q-card-section class="text-body2">
              <translate>
                No messages.
              </translate>
            </q-card-section>
          </q-card>
        </template>
      </div>

      <q-page-sticky
        v-if="!isDesktopPlatform"
        position="bottom-right"
        :offset="[18, 18]"
      >
        <q-btn
          fab
          icon="las la-pen"
          color="accent"
          @click="onClickNewMessage"
        />
      </q-page-sticky>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import BroadcastListItem from 'src/pages/messaging/components/BroadcastListItem'
import TicketListItem from 'src/pages/messaging/components/TicketListItem'
import queryMessages from './graphql/queryMessages.gql'
import queryHoldings from './graphql/queryHoldings.gql'
import featureFlags from 'src/services/feature-flags'

// this is a hack to properly cache messages
const FUTURE_DATE = new Date(2100, 1, 1)

export default {
  name: 'MessagingPage',
  mixins: [
    PlatformMixin
  ],
  components: {
    GenericLayout,
    Header,
    Footer,
    BroadcastListItem,
    TicketListItem
  },
  data () {
    return {
      holdings: null
    }
  },
  apollo: {
    messages: {
      query: queryMessages,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          limit: this.numberToLoadPerRequest,
          lastUpdatedAtCursor: FUTURE_DATE
        }
      }
    },
    holdings: {
      query: queryHoldings,
      notifyOnNetworkStatusChange: true,
      update: data => data.holding
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Messaging')
    },
    numberToLoadPerRequest () {
      return this.isDesktopPlatform ? 25 : 15
    },
    loading () {
      return (!this.messages && this.$apollo.queries.messages.loading) ||
        (!this.holdings && this.$apollo.queries.holdings.loading)
    },
    canCreateTicket () {
      return featureFlags.canCreateTicket()
    },
    canDisplayBroadcast () {
      return featureFlags.canDisplayBroadcast()
    },
    canDisplayTicket () {
      return featureFlags.canDisplayTicket()
    },
    formattedMessages () {
      if (!this.messages) {
        return []
      }
      // TODO move filters to query variables
      return this.messages.filter(message => {
        return (
          (message.messageType === 'broadcast' && this.canDisplayBroadcast) ||
          (message.messageType === 'ticket' && this.canDisplayTicket)
        )
      }).map(message => {
        const { id, messageId, messageType, updatedAt, broadcast, ticket } = message
        const listItemMessage = {
          key: id,
          messageId,
          messageType,
          updatedAt
        }
        if (messageType === 'broadcast') {
          return { ...broadcast, ...listItemMessage }
        } else if (messageType === 'ticket') {
          return { ...ticket, ...listItemMessage }
        }
        return null
      })
    }
  },
  methods: {
    onClickNewMessage () {
      this.$router.push({ name: 'messageCreation' })
    },
    onClickMessage (message) {
      this.$router.push({ name: 'message', params: { messageType: message.messageType, messageId: message.messageId } })
    },
    onLoadMoreMessages (index, done) {
      if (!this.messages || this.$apollo.queries.messages.loading) {
        // wait for initial message fetch
        done()
        return
      } else if (this.messages.length < this.numberToLoadPerRequest) {
        // initial query loaded all messages
        done(true)
        return
      }

      const lastMessage = this.messages?.[this.messages.length - 1]
      this.$apollo.queries.messages.fetchMore({
        variables: {
          lastUpdatedAtCursor: lastMessage.updatedAt
        },
        updateQuery: (previousResult, { fetchMoreResult }) => {
          return {
            messages: [...previousResult.messages, ...fetchMoreResult.messages]
          }
        }
      }).then(({ data }) => {
        if (data?.messages?.length < this.numberToLoadPerRequest) {
          // no more messages
          done(true)
        } else {
          // potentially more messages to load
          done()
        }
      }).catch(e => {
        console.error(e)
        // prevent the infinite scroll component to load more data since there was an error
        done(true)
      })
    },
    whichListItemComponent (message) {
      switch (message.messageType) {
        case 'broadcast':
          return BroadcastListItem
        case 'ticket':
          return TicketListItem
      }
    }
  }
}
</script>
